
/* Generated by Interface Builder */

#import "GopherClient.h"

// Declared in GopherDispatcher.m
extern char defaultHost[256];
extern int defaultPort;

static int isIndexedText = NO;
static char lastIndexWord[256];

@implementation GopherClient

///////////////////////////////////////////////////
//

- (char *)currentCellName
{
id CurrentCell;

CurrentCell = [[MainScroller matrixInColumn:[MainScroller selectedColumn]] 
																selectedCell];
return [CurrentCell stringValue];
}

//////////////////////////////////////////////////
// Compute a new location for a window.

static void newLocation(NXPoint *p)
{
static count = 0;

p->x += (20.0 * count);
p->y -= (25.0 * count);
count = (count > 10)? 0 : count+1;
}

//////////////////////////////////////////////////
// Automatically called by the system when an instance is created.

- init
{
NXRect 	theFrame;

[super init];

strncpy(currenthostname, defaultHost, 250);
strncpy(currentfilename, "\r\n", 250);
currentport = defaultPort;

[NXApp loadNibSection:"GopherClient.nib" owner:self];
//[myWindow setDelegate:self];
[myWindow getFrame:&theFrame];
newLocation(&theFrame.origin);
[myWindow moveTo:theFrame.origin.x :theFrame.origin.y];
[myWindow makeKeyAndOrderFront:nil];

[[MainText docView] setAutodisplay:YES];

[MainScroller setCellClass:[GopherBrowserCell class]];
[MainScroller useScrollButtons:YES];
[MainScroller loadColumnZero];

return self;
}

/////////////////////////////////////////////////
// Close the window.

- close
{
[myWindow performClose:self];
[self clean];
[myDispatcher oldFrontWindow:self];		// Theoretically unnecessary

return self;
}

/////////////////////////////////////////////////
// Clean things up.

- clean
{
[ItemInfoPanel performClose:self];
return self;
}

/////////////////////////////////////////////////
// Target method for the browser.

- cellClicked:sender
{
id 		CurrentCell;
char	commandString[256];
int		result;
char	oldShell[256];
int		remotePort;
ThreadArgument *theArg;

CurrentCell = [[sender matrixInColumn:[sender selectedColumn]] selectedCell];

[ItemInfoHostName setStringValue:[CurrentCell remoteHost]];
[ItemInfoFileName setStringValue:[CurrentCell remoteName]];
[ItemInfoPortNumber setIntValue:[CurrentCell remotePort]];

switch ([CurrentCell cellType])
	{
	case '0' : 			// Document : retrieve and display
		strncpy(currenthostname, [CurrentCell remoteHost], 255);
		strncpy(currentfilename, [CurrentCell remoteName], 255);
		currentport = [CurrentCell remotePort];
		[self displayDocument];
		break;
	case '1' :			// Directory : do nothing, taken care of in 
						// 				browser:fillMatrix:inColumn:
		isIndexedText = NO;
		[[MainText docView] setText:""];
		break;
	case '7' :			// Index search
		isIndexedText = YES;
		[[MainText docView] setText:""];
		break;
	case '8' :			// Telnet session. This is very ugly.
		isIndexedText = NO;
		[[MainText docView] setText:""];
		if ([CurrentCell remotePort] == 0)		// Seems common, so fix it
			remotePort = 23;
		else
			remotePort = [CurrentCell remotePort];
		sprintf(commandString, "/usr/ucb/telnet %s %i",
					[CurrentCell remoteHost], remotePort);
					
		strncpy(oldShell, NXReadDefault("Terminal", "Shell"), 255);
		NXWriteDefault("Terminal", "Shell", commandString);
		[[NXApp appSpeaker] 
				setSendPort:NXPortFromName(NX_WORKSPACEREQUEST,NULL)];
		[[NXApp appSpeaker] openFile:"/NextApps/Terminal" ok:&result];
		
		sleep(5);		// Bleechhh....
		NXWriteDefault("Terminal", "Shell", oldShell);
		break;
	case 's' :			// Sound
		isIndexedText = NO;
		[[MainText docView] setText:""];
		// Check that we're the only thread. We do it here because
		// we can't have NXRunAlertPanel in a thread (why not ?)
		if (mutex_try_lock(soundIsPlaying) == 0)
			{
			NXRunAlertPanel("Gopher error", "Only one sound at a time !",
															"OK", NULL, NULL);
			break;
			}
		
		mutex_unlock(soundIsPlaying);
		
		soundShouldStopFlag = 0;
		// The argument is malloc'ed because we may have several threads.
		theArg = malloc(sizeof(ThreadArgument));
		strncpy(theArg->hostname, [CurrentCell remoteHost], 255);
		theArg->portnumber = [CurrentCell remotePort];
		strncpy(theArg->filename, [CurrentCell remoteName], 1023);
		cthread_detach(
				cthread_fork((cthread_fn_t)PlaySound, (any_t)theArg));
		break;
	default :
		break;
	}

return self;
}

////////////////////////////////////////////////////////////////
// Connect to currenthostname on port currentport, retrieve
// document currentfilename and display it.

- displayDocument
{
int iLength = 1, i;
int currentsocket;
char *theText;
int		findIndex, spaceIndex;

currentsocket = create_socket(currenthostname, currentport);
if ( currentsocket < 0)
	{
	switch (currentsocket)
		{
		case -1 :
			NXRunAlertPanel("Gopher error", "Unknown host", "OK", NULL, NULL);
			return self;
			break;
		case -2 :
			NXRunAlertPanel("Gopher error", "Socket call failed",
															"OK", NULL, NULL);
			return self;
			break;
		case -3 :
			NXRunAlertPanel("Gopher error", "Connect call failed",
															"OK", NULL, NULL);
			return self;
			break;
		default :
			break;
		}
	}

writestring(currentsocket, currentfilename);
writestring(currentsocket, "\r\n");

theText = (char *)malloc(MAXTEXTLENGTH);
for (i=0; (i < MAXTEXTLENGTH) && iLength; i += iLength)
	iLength = read(currentsocket, theText + i, 10000);
	
theText[i - 3] = '\0';		// -3 to get rid of final period
[[MainText docView] setText:theText];

close(currentsocket);

[[MainText docView] setSel:0 :0];
[[MainText docView] scrollSelToVisible];

if (isIndexedText)
	{
	findIndex = (int)strstr(theText, lastIndexWord);
	if (findIndex == 0)
		;		// Not found
	else
		{
		spaceIndex = (int)index((char *)findIndex, ' ');
		findIndex = (int)findIndex - (int)theText;
		spaceIndex = (int)spaceIndex - (int)theText;
		[[MainText docView] setSel:findIndex :spaceIndex];
		[[MainText docView] scrollSelToVisible];
		}
	}

free(theText);

return self;
}

/////////////////////////////////////////////////
// Find our dispatcher

- setDispatcher:sender
{
myDispatcher = sender;
return self;
}

/////////////////////////////////////////////////
// Print the contents of the text window.

- print
{
[[MainText docView] printPSCode:self];

return self;
}

/////////////////////////////////////////////////
// Saves the contents of the text window.

- saveAs:(char *)filename
{
NXStream *tmpstream;

tmpstream = NXOpenMemory(NULL, 0, NX_WRITEONLY);
[[MainText docView] writeText:tmpstream];
NXSaveToFile(tmpstream, filename);
NXCloseMemory(tmpstream, NX_FREEBUFFER);

return self;
}

/////////////////////////////////////////////////
// 

- searchIndex:sender
{
[myIndexPanel orderOut:self];
[NXApp stopModal:1];

return self;
}

/////////////////////////////////////////////////
// 

- cancelIndex:sender
{
[myIndexPanel orderOut:self];
[NXApp stopModal:2];

return self;
}

/////////////////////////////////////////////////
// 

- getIndexString:(char *)theString maxLength:(int)maxlength
{
[myIndexPanel makeKeyAndOrderFront:self];
[IndexTextItem selectText:self];
if ([NXApp runModalFor:myIndexPanel] == 1)	// User clicked OK
	strncpy(theString, [IndexTextItem stringValue], maxlength);
else
	strcpy(theString, "");			// User clicked Cancel

return self;
}

/////////////////////////////////////////////////
//

- showItemInfo
{
[ItemInfoPanel makeKeyAndOrderFront:self];
return self;
}

/////////////////////////////////////////////////
// Delegate method for the browser

- (int)browser:sender fillMatrix:matrix inColumn:(int)column
{
id		tmpcell;
int 	iLength;
char 	inputline[512];
char 	*remotename, *remotehost, *remoteport;
int 	currentsocket;
id 		CurrentCell;

CurrentCell = [[sender matrixInColumn:[sender selectedColumn]] selectedCell];

switch ([CurrentCell cellType])
	{
	case '0' : 			// Document : should never happen
		break;
	case '1' :			// Directory : the browser will automatically update
		strncpy(currenthostname, [CurrentCell remoteHost], 250);
		strncpy(currentfilename, [CurrentCell remoteName], 250);
		currentport = [CurrentCell remotePort];
		break;
	case '7' :			// Index search
		strncpy(currenthostname, [CurrentCell remoteHost], 250);
		[self getIndexString:&currentfilename maxLength:250];
		strncpy(lastIndexWord, currentfilename, 255);
		if (strlen(currentfilename) == 0)		// User clicked Cancel
			return 0;
		currentport = [CurrentCell remotePort];
		break;
	case '8' :			// Telnet session : should never happen
		break;
	case 's' :			// Sound : should never happen
		break;
	default :
		break;
	}

currentsocket = create_socket(currenthostname, currentport);
if ( currentsocket < 0)
	{
	switch (currentsocket)
		{
		case -1 :
			NXRunAlertPanel("Gopher error", "Unknown host",
													"OK", NULL, NULL);
			return(0);
			break;
		case -2 :
			NXRunAlertPanel("Gopher error", "Socket call failed",
													"OK", NULL, NULL);
			return(0);
			break;
		case -3 :
			NXRunAlertPanel("Gopher error", "Connect call failed",
													"OK", NULL, NULL);
			return(0);
			break;
		default :
			break;
		}
	}

writestring(currentsocket, currentfilename);
writestring(currentsocket, "\r\n");

for(;;)
	{
	iLength = readline(currentsocket, inputline, 512);
	  
	if (iLength == 0)
		break;

	ZapCRLF(inputline);
	  
	if ((inputline[0] == '0') || (inputline[0] == '1') ||
		(inputline[0] == '7') || (inputline[0] == '8') ||
		(inputline[0] == 's'))
		{
		if (inputline[0] == 's')
			if (shouldUseSound == 0)
				continue;

		[matrix addRow];
		tmpcell = [matrix cellAt:([matrix cellCount] -1) :0];
		
		remotename = index(inputline, '\t') + 1;
		*(remotename-1) = '\0';
		
		remotehost = index(remotename, '\t') + 1;
		*(remotehost-1) = '\0';
		
		remoteport = index(remotehost, '\t') + 1;
		*(remoteport-1) = '\0';

		[tmpcell setRemoteName:remotename];
		[tmpcell setRemoteHost:remotehost];
		[tmpcell setRemotePort:atoi(remoteport)];
		[tmpcell setStringValue:(inputline+1)];
		[tmpcell setLoaded:YES];
		if (inputline[0] == '0')		// Document
			{
			[tmpcell setLeaf:YES];
			[tmpcell setCellType:'0'];
			}
		else if (inputline[0] == '1')	// Directory
			{
			[tmpcell setLeaf:NO];
			[tmpcell setCellType:'1'];
			}
		else if (inputline[0] == '7')	// Index
			{
			[tmpcell setLeaf:NO];
			[tmpcell setCellType:'7'];
			}
		else if (inputline[0] == '8')	// Telnet
			{
			[tmpcell setLeaf:YES];
			[tmpcell setCellType:'8'];
			}
		else if (inputline[0] == 's')	// Sound
			{
			[tmpcell setLeaf:YES];
			[tmpcell setCellType:'s'];
			}
		}
	
	if ((inputline[0] == '.') && (inputline[1] == '\0'))
		break;
	}

close(currentsocket);

return([matrix cellCount]);
}

////////////////////////////////////////////////////////////////////////////
// Delegate methods for the window

/////////////////////////////////////////////////
// Called when our window becomes the key window.

- windowDidBecomeKey:sender
{
[myDispatcher newFrontWindow:self];

return self;
}

/////////////////////////////////////////////////
// Called when our window has stopped being the key window.

- windowDidResignKey:sender
{
[myDispatcher oldFrontWindow:self];

return self;
}

/////////////////////////////////////////////////
// Called when our window is going to close.

- windowWillClose:sender
{
[self clean];
[myDispatcher oldFrontWindow:self];

return self;
}

@end
